<?php

namespace UnicaenDbImport\CodeGenerator\Oracle;

use UnicaenDbImport\CodeGenerator\Oracle;
use UnicaenDbImport\Platforms\OraclePlatform;

/**
 * Version Oracle.
 *
 * @author Unicaen
 *
 * @property Oracle\Helper\TableHelper $tableHelper
 * @property Oracle\Helper\TableValidationHelper $tableValidationHelper
 * @property Oracle\Helper\LogTableHelper $logTableHelper
 */
class CodeGenerator extends \UnicaenDbImport\CodeGenerator\CodeGenerator
{
    /**
     * CodeGenerator constructor.
     */
    public function __construct()
    {
        $this->platform = new OraclePlatform();
    }

    /**
     * @inheritDoc
     */
    public function generateSQLForInsertIntoTable(
        string $tableName,
        array $columnsValues,
        string $sourceCode,
        $idColumnSequence = null): string
    {
        // les ; séparant les INSERTs perturbent le driver Oracle donc on met tout dans un bloc BEGIN END et miracle...
        return
            'BEGIN ' . PHP_EOL .
            parent::generateSQLForInsertIntoTable($tableName, $columnsValues, $sourceCode, $idColumnSequence) .
            'END;';
    }

    /**
     * @inheritDoc
     */
    public function generateSQLForIntermmediateTableDrop($tableName): string
    {
        return "DROP TABLE $tableName CASCADE CONSTRAINTS ;";
    }
}