<?php

namespace UnicaenDbImport\Controller;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Service\ImportService;
use UnicaenDbImport\Service\SynchroService;

class ConsoleControllerFactory
{
    function __invoke(ContainerInterface $sl)
    {
        /** @var ImportService $importService */
        $importService = $sl->get(ImportService::class);
        $synchroService = $sl->get(SynchroService::class);

        $controller = new ConsoleController();
        $controller->setImportService($importService);
        $controller->setSynchroService($synchroService);

        return $controller;
    }
}