<?php

namespace UnicaenDbImport\Controller;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Entity\Db\Service\ImportLog\ImportLogService;
use UnicaenDbImport\Service\ImportService;

class ImportControllerFactory
{
    function __invoke(ContainerInterface $sl): ImportController
    {
        /** @var ImportService $importService */
        $importService = $sl->get(ImportService::class);

        /** @var ImportLogService $importLogService */
        $importLogService = $sl->get(ImportLogService::class);

        $controller = new ImportController();
        $controller->setImportService($importService);
        $controller->setImportLogService($importLogService);

        return $controller;
    }
}