<?php

namespace UnicaenDbImport\Controller;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Entity\Db\Service\ImportLog\ImportLogService;
use UnicaenDbImport\Service\SynchroService;

class SynchroControllerFactory
{
    function __invoke(ContainerInterface $sl): SynchroController
    {
        /** @var SynchroService $synchroService */
        $synchroService = $sl->get(SynchroService::class);

        /** @var ImportLogService $importLogService */
        $importLogService = $sl->get(ImportLogService::class);

        $controller = new SynchroController();
        $controller->setSynchroService($synchroService);
        $controller->setImportLogService($importLogService);

        return $controller;
    }
}