<?php

namespace UnicaenDbImport\Filter\ColumnName;

class ArrayMapColumnNameFilter implements ColumnNameFilterInterface
{
    /**
     * Tableau de correspondance ['colonne_ou_attribut_source' => 'colonne_destination'].
     *
     * @var array Ex: ['nomDeFamille' => 'NOM_USUEL', 'prenom' => 'PRENOM']
     */
    protected $mapping;

    /**
     * @param array $mapping Tableau de correspondance ['colonne_ou_attribut_source' => 'colonne_destination'].
     */
    public function __construct(array $mapping)
    {
        $this->mapping = $mapping;
    }

    /**
     * Fournit le nom de colonne dans la destination à partir du nom de colonne/attribut dans la source.
     *
     * @param string $name Nom de colonne ou attribut dans la source
     * @return string Nom de colonne dans la destination
     */
    public function filter(string $name): string
    {
        return $this->mapping[$name] ?? $name;
    }
}