<?php

namespace UnicaenDbImport\Filter\ColumnValue;

use UnicaenDbImport\Domain\Source;

/**
 * Interface de transformation d'une valeur de colonne/attribut issu de la source
 * en une valeur de colonne destination.
 *
 * @author Unicaen
 */
interface ColumnValueFilterInterface
{
    /**
     * @param \UnicaenDbImport\Domain\Source $source
     */
    public function setSource(Source $source);

    /**
     * @param string $name Nom de colonne/attribut source
     * @param mixed $value Valeur de colonne/attribut source
     * @return mixed Valeur de colonne destination
     */
    public function filter(string $name, $value);
}