<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Config\Config;
use Laminas\ServiceManager\Factory\FactoryInterface;

class CodeGeneratorPluginManagerFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param null|array $options
     * @return CodeGeneratorPluginManager
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $factoriesConfig = $this->getCodeGeneratorPluginFactories($container);

        return new CodeGeneratorPluginManager($container, [
            'factories' => $factoriesConfig,
        ]);
    }

    /**
     * @param ContainerInterface $container
     * @return array
     */
    protected function getCodeGeneratorPluginFactories(ContainerInterface $container)
    {
        /** @var Config $config */
        $config = $container->get(Config::class);

        return $config->getCodeGeneratorsFactoriesConfig();
    }
}