<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Config\Config;
use UnicaenDbImport\Entity\Db\Service\ImportObserv\ImportObservService;
use UnicaenDbImport\QueryExecutor;

class DatabaseServiceFactory
{
    /**
     * @param ContainerInterface $container
     * @return DatabaseService
     */
    public function __invoke(ContainerInterface $container)
    {
        /** @var ImportObservService $importObservService */
        $importObservService = $container->get(ImportObservService::class);

        /** @var Config $config */
        $config = $container->get(Config::class);

        /** @var CodeGeneratorPluginManager $codeGeneratorPluginManager */
        $codeGeneratorPluginManager = $container->get(CodeGeneratorPluginManager::class);

        $codeGeneratorsConfig = $config->getCodeGeneratorsMappingConfig();

        $service = new DatabaseService(
            $codeGeneratorPluginManager,
            $codeGeneratorsConfig,
            new QueryExecutor()
        );
        $service->setImportObservService($importObservService);

        return $service;
    }
}