<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Config\Config;

class FacadeServiceFactory
{
    /**
     * @param ContainerInterface $container
     * @return FacadeService
     */
    public function __invoke(ContainerInterface $container)
    {
        /** @var Config $config */
        $config = $container->get(Config::class);

        /** @var DatabaseService $databaseService */
        $databaseService = $container->get(DatabaseService::class);

        /** @var ApiService $apiService */
        $apiService = $container->get(ApiService::class);

        $facade = new FacadeService($databaseService, $apiService);
        $facade->setUseImportObserv($config->getUseImportObserv());

        return $facade;
    }
}